=== debian/changelog ===
modules (5.0.0-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.6.0

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 14 Sep 2021 10:51:51 +0100
