## modules 5.0.1

=== Makefile ===
--- 
+++ 
@@ -10,9 +10,9 @@
 
 # definitions for code coverage
 NAGELFAR_DLSRC1 := http://downloads.sourceforge.net/nagelfar/
-NAGELFAR_RELEASE := nagelfar131
+NAGELFAR_RELEASE := nagelfar132
 NAGELFAR_DIST := $(NAGELFAR_RELEASE).tar.gz
-NAGELFAR_DISTSUM := fbf79ab1a1d85349600f2502a3353bf4
+NAGELFAR_DISTSUM := 2a85579f57492863de286a484fe061ed
 NAGELFAR := $(NAGELFAR_RELEASE)/nagelfar.tcl
 
 # definition for old Tcl interpreter for coverage testing
@@ -26,8 +26,8 @@
 MODULECMDTEST := modulecmd-test.tcl
 
 # definitions for enhanced diff tool (to review test results)
-ICDIFF_DLSRC := https://raw.githubusercontent.com/jeffkaufman/icdiff/release-1.9.5/
-ICDIFF_CHECKSUM := fd5825ede4c2853ba1747a8931b077c1
+ICDIFF_DLSRC := https://raw.githubusercontent.com/jeffkaufman/icdiff/release-2.0.4/
+ICDIFF_CHECKSUM := 597bd4cda393803e5991c43b78cab3b3
 
 # source definitions shared across the Makefiles of this project
 ifneq ($(wildcard Makefile.inc),Makefile.inc)
