=== debian/changelog ===
modules (5.0.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 20 Oct 2021 13:40:53 +0100
