## modules 5.1.0

=== Makefile ===
--- 
+++ 
@@ -21,6 +21,13 @@
 TCL_DIST83 := $(TCL_RELEASE83)-src.tar.gz
 TCL_DISTSUM83 := 5cb79f8b90cf1322cb1286b9fe67f7a2
 TCLSH83 := $(TCL_RELEASE83)/unix/tclsh
+
+# third-party definitions for source-sh testing
+SPACK_REPOURL := https://github.com/spack/spack.git
+MINICONDA_DLSRC := https://repo.anaconda.com/miniconda/
+MINICONDA_DIST := Miniconda3-py38_4.11.0-Linux-x86_64.sh
+MINICONDA_DISTSUM := 252d3b0c863333639f99fbc465ee1d61
+OPENFOAM_REPOURL := https://github.com/OpenFOAM/OpenFOAM-dev.git
 
 # specific modulecmd script for test
 MODULECMDTEST := modulecmd-test.tcl
@@ -54,13 +61,19 @@
 	lib/libtestutil-dupgetgroups$(SHLIB_SUFFIX) \
 	lib/libtestutil-getgrgid$(SHLIB_SUFFIX) \
 	lib/libtestutil-time$(SHLIB_SUFFIX) \
-	lib/libtestutil-mktime$(SHLIB_SUFFIX)
+	lib/libtestutil-mktime$(SHLIB_SUFFIX) \
+	lib/libtestutil-sysconf$(SHLIB_SUFFIX)
 endif
 endif
 
 # install old Tcl interpreters to test coverage
 ifeq ($(COVERAGE_OLDTCL),y)
 TEST_PREREQ += tclsh83
+endif
+
+# install extra software to test source-sh against their scripts
+ifeq ($(EXTRATEST_SOURCESH),y)
+TEST_PREREQ += spack miniconda3 OpenFOAM-dev
 endif
 
 # define rule prereq when target need to be rebuilt when git repository change
@@ -344,6 +357,9 @@
 contrib/rpm/environment-modules.spec: contrib/rpm/environment-modules.spec.in $(GIT_REFRESH_PREREQ)
 	$(translate-in-script)
 
+tcl/coll.tcl: tcl/coll.tcl.in version.inc
+	$(translate-in-script)
+
 tcl/envmngt.tcl: tcl/envmngt.tcl.in version.inc
 	$(translate-in-script)
 
@@ -389,13 +405,3 @@
 		-e '1d' -e '/^# vim:/d' -e '/^# ;;;/d' tcl/init.tcl >> $@
 	sed -e '1,22d' -e '/^# vim:/d' -e '/^# ;;;/d' tcl/util.tcl >> $@
 	sed -e '1,22d' -e '/^# vim:/d' -e '/^# ;;;/d' tcl/envmngt.tcl >> $@
-	sed -e '1,22d' -e '/^# vim:/d' -e '/^# ;;;/d' tcl/report.tcl >> $@
-	sed -e '1,22d' -e '/^# vim:/d' -e '/^# ;;;/d' tcl/mfinterp.tcl >> $@
-	sed -e '1,22d' -e '/^# vim:/d' -e '/^# ;;;/d' tcl/modfind.tcl >> $@
-	sed -e '1,22d' -e '/^# vim:/d' -e '/^# ;;;/d' tcl/modeval.tcl >> $@
-	sed -e '1,20d' -e '/^# vim:/d' -e '/^# ;;;/d' tcl/modspec.tcl >> $@
-	sed -e '1,20d' -e '/^# vim:/d' -e '/^# ;;;/d' tcl/coll.tcl >> $@
-	sed -e '1,22d' -e '/^# vim:/d' -e '/^# ;;;/d' tcl/subcmd.tcl >> $@
-	sed -e '1,22d' -e '/^# vim:/d' -e '/^# ;;;/d' tcl/main.tcl >> $@
-	chmod +x $@
-
