=== init/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 # use bash shell to correctly expand the $'' syntax used in translate-in-script
 SHELL = /usr/bin/env bash
 
-SH_LIKE  = sh ksh bash zsh profile.sh bash_completion
+SH_LIKE  = sh ksh bash zsh profile.sh
 CSH_LIKE = csh tcsh tcsh_completion profile.csh
 OTHER    = perl.pm python.py ruby.rb lisp tcl fish cmake r.R
 
@@ -43,7 +43,7 @@
 
 ALL_SHELLS = $(SH_LIKE) $(CSH_LIKE) $(OTHER)
 
-all: $(ALL_SHELLS) initrc zsh-functions/_module $(EXAMPLE_MODFILES_SRCDIR)/modules
+all: $(ALL_SHELLS) initrc bash_completion zsh-functions/_module $(EXAMPLE_MODFILES_SRCDIR)/modules
 ifeq ($(versioning),y)
 all: $(EXAMPLE_MODFILES_SRCDIR)/version
 endif
@@ -69,6 +69,30 @@
 else
   modulespath := $(initdir)/.modulespath
   initrc := $(initdir)/modulerc
+endif
+
+# define shell completion location
+ifeq ($(bashcompletiondir),)
+  bashcompletiondir := $(initdir)
+  makebashcompdir := n
+  sourcebashcompre := s|@sourcebashcomp@||g
+else
+  makebashcompdir := y
+  sourcebashcompre := /@sourcebashcomp@/d
+endif
+ifeq ($(fishcompletiondir),)
+  fishcompletiondir := $(initdir)
+  makefishcompdir := n
+  sourcefishcompre := s|@sourcefishcomp@||g
+else
+  makefishcompdir := y
+  sourcefishcompre := /@sourcefishcomp@/d
+endif
+ifeq ($(zshcompletiondir),)
+  zshcompletiondir := $(initdir)/zsh-functions
+  setzshfpathre := s|@setzshfpath@||g
+else
+  setzshfpathre := /@setzshfpath@/d
 endif
 
 # if enabled translate to keep text after markup elsewhere remove the
@@ -131,9 +155,10 @@
 endif
 
 # define variables for shell completion
-comp_cmds := add apropos aliases avail append-path clear config del display edit help initadd initclear initlist initprepend initrm is-loaded is-saved is-used is-avail info-loaded keyword list load path paths purge prepend-path refresh reload restore rm remove remove-path save savelist saveshow saverm search show sh-to-mod source swap switch test try-add try-load unload unuse use whatis
+comp_cmds := add add-any apropos aliases avail append-path clear config del display edit help initadd initclear initlist initprepend initrm is-loaded is-saved is-used is-avail info-loaded keyword list load load-any path paths purge prepend-path refresh reload restore rm remove remove-path save savelist saveshow saverm search show sh-to-mod source state swap switch test try-add try-load unload unuse use whatis
 comp_opts := -D -h -s -T -v -V -w --debug --help --silent --trace --verbose --version --paginate --no-pager --color --color= --width --width=
-comp_load_opts := --auto --no-auto --force -f --icase -i
+comp_load_opts := --auto --no-auto --force -f --icase -i --tag --tag=
+comp_unload_opts := --auto --no-auto --force -f --icase -i
 comp_list_opts := -a -j -l -o -t --all --json --long --output --output= --terse
 comp_clear_opts := --force -f
 comp_avail_opts := -a -C -d -i -j -L -l -o -S -t --all --contains --default --icase --json --latest --long --output --output= --starts-with --terse --indepth --no-indepth
@@ -144,7 +169,7 @@
 comp_isavail_opts := -a -i --all --icase
 comp_path_opts := -d --delim --duplicates
 comp_rm_path_opts := -d --delim --index
-comp_config_opts := --dump-state --reset advanced_version_spec auto_handling avail_indepth avail_output avail_terse_output collection_pin_version collection_target color colors contact editor extended_default extra_siteconfig home icase implicit_default implicit_requirement list_output list_terse_output locked_configs mcookie_version_check ml nearly_forbidden_days pager quarantine_support rcfile run_quarantine search_match set_shell_startup shells_with_ksh_fpath silent_shell_debug tag_abbrev tag_color_name term_background term_width unload_match_order variant_shortcut verbosity wa_277
+comp_config_opts := --dump-state --reset advanced_version_spec auto_handling avail_indepth avail_output avail_terse_output collection_pin_version collection_pin_tag collection_target color colors contact editor extended_default extra_siteconfig home icase implicit_default implicit_requirement list_output list_terse_output locked_configs mcookie_check mcookie_version_check ml nearly_forbidden_days pager quarantine_support rcfile redirect_output run_quarantine search_match set_shell_startup shells_with_ksh_fpath silent_shell_debug tag_abbrev tag_color_name term_background term_width unload_match_order variant_shortcut verbosity wa_277
 
 define translate-in-script
 $(ECHO_GEN)
@@ -159,6 +184,7 @@
 	-e 's|@comp_cmds@|$(comp_cmds)|g' \
 	-e 's|@comp_opts@|$(comp_opts)|g' \
 	-e 's|@comp_load_opts@|$(comp_load_opts)|g' \
+	-e 's|@comp_unload_opts@|$(comp_unload_opts)|g' \
 	-e 's|@comp_list_opts@|$(comp_list_opts)|g' \
 	-e 's|@comp_clear_opts@|$(comp_clear_opts)|g' \
 	-e 's|@comp_avail_opts@|$(comp_avail_opts)|g' \
@@ -178,6 +204,9 @@
 	-e '$(prependbinpathre)' \
 	-e '$(usemanpathre)' \
 	-e '$(notusemanpathre)' \
+	-e '$(setzshfpathre)' \
+	-e '$(sourcebashcompre)' \
+	-e '$(sourcefishcompre)' \
 	-e $$'s|@modulerc@|$(modulerc)|g' \
 	-e 's|@modulepath@|$(modulepath)|g' \
 	-e '$(setquarvarsre)' $(quarvarsre) \
@@ -243,14 +272,30 @@
 install: all
 	mkdir -p $(DESTDIR)$(initdir)
 	mkdir -p $(DESTDIR)$(initdir)/ksh-functions
-	mkdir -p $(DESTDIR)$(initdir)/zsh-functions
+ifeq ($(makebashcompdir),y)
+	mkdir -p $(DESTDIR)$(bashcompletiondir)
+endif
+ifeq ($(makefishcompdir),y)
+	mkdir -p $(DESTDIR)$(fishcompletiondir)
+endif
+	mkdir -p $(DESTDIR)$(zshcompletiondir)
 	mkdir -p $(DESTDIR)$(modulefilesdir)
 	cp $(ALL_SHELLS) $(DESTDIR)$(initdir)/
 ifeq ($(windowssupport),y)
 	cp cmd.cmd $(DESTDIR)$(initdir)/
 endif
-	cp fish_completion $(DESTDIR)$(initdir)/
-	cp zsh-functions/_module $(DESTDIR)$(initdir)/zsh-functions/
+ifeq ($(makefishcompdir),y)
+	cp fish_completion $(DESTDIR)$(fishcompletiondir)/module.fish
+else
+	cp fish_completion $(DESTDIR)$(fishcompletiondir)/
+endif
+ifeq ($(makebashcompdir),y)
+	cp bash_completion $(DESTDIR)$(bashcompletiondir)/module
+	ln -s module $(DESTDIR)$(bashcompletiondir)/ml
+else
+	cp bash_completion $(DESTDIR)$(bashcompletiondir)/
+endif
+	cp zsh-functions/_module $(DESTDIR)$(zshcompletiondir)/
 	cp ksh $(DESTDIR)$(initdir)/ksh-functions/module
 	cp ksh $(DESTDIR)$(initdir)/ksh-functions/ml
 	rm -f $(DESTDIR)$(modulespath) $(DESTDIR)$(initrc)
@@ -267,38 +312,21 @@
 endif
 
 uninstall:
-	rm -f $(addprefix $(DESTDIR)$(initdir)/,$(ALL_SHELLS) fish_completion)
+	rm -f $(addprefix $(DESTDIR)$(initdir)/,$(ALL_SHELLS))
 ifeq ($(windowssupport),y)
 	rm -f $(DESTDIR)$(initdir)/cmd.cmd
 endif
 	rm -f $(DESTDIR)$(initdir)/ksh-functions/module
 	rm -f $(DESTDIR)$(initdir)/ksh-functions/ml
-	rm -f $(DESTDIR)$(initdir)/zsh-functions/_module
-	rm -f $(DESTDIR)$(modulespath) $(DESTDIR)$(initrc)
-	$(RMDIR_IGN_NON_EMPTY) $(DESTDIR)$(modulefilesdir) || true
-	@if [ -d $(DESTDIR)$(modulefilesdir) ]; then echo; echo "WARNING: $(DESTDIR)$(modulefilesdir) is not empty so skip removal" >&2; echo; fi
-	rmdir $(DESTDIR)$(initdir)/ksh-functions
-	rmdir $(DESTDIR)$(initdir)/zsh-functions
-	$(RMDIR_IGN_NON_EMPTY) $(DESTDIR)$(initdir) || true
-	@if [ -d $(DESTDIR)$(initdir) ]; then echo; echo "WARNING: $(DESTDIR)$(initdir) is not empty so skip removal" >&2; echo; fi
-ifeq ($(versioning),y)
-	rm -f $(DESTDIR)$(versdir)/$(VERSION)
-	$(RMDIR_IGN_NON_EMPTY) $(DESTDIR)$(versdir) || true
-	@if [ -d $(DESTDIR)$(versdir) ]; then echo; echo "WARNING: $(DESTDIR)$(versdir) is not empty so skip removal" >&2; echo; fi
-endif
-
-clean:
-	rm -f $(ALL_SHELLS) initrc zsh-functions/_module modulespath $(EXAMPLE_MODFILES_SRCDIR)/modules
-ifeq ($(versioning),y)
-	rm -f $(EXAMPLE_MODFILES_SRCDIR)/version
-endif
-
-# quiet all commands unless verbose mode set
-ifeq ($(VERBOSE),1)
-V = 1
-endif
-# let verbose by default the install/clean/test and other specific non-build targets
-$(V).SILENT: ../version.inc sh ksh bash zsh csh tcsh fish perl.pm python.py ruby.rb \
-	lisp tcl cmake r.R bash_completion tcsh_completion zsh-functions/_module \
-	profile.sh profile.csh modulespath initrc $(EXAMPLE_MODFILES_SRCDIR)/modules \
-	$(EXAMPLE_MODFILES_SRCDIR)/version
+ifeq ($(makebashcompdir),y)
+	rm -f $(DESTDIR)$(bashcompletiondir)/ml
+	rm -f $(DESTDIR)$(bashcompletiondir)/module
+else
+	rm -f $(DESTDIR)$(bashcompletiondir)/bash_completion
+endif
+ifeq ($(makefishcompdir),y)
+	rm -f $(DESTDIR)$(fishcompletiondir)/module.fish
+else
+	rm -f $(DESTDIR)$(fishcompletiondir)/fish_completion
+endif
+	rm -f $(DESTDIR)$(zshcompletiondir)/_module
