=== debian/changelog ===
modules (5.1.0-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 04 May 2022 08:42:50 +0100
