=== init/Makefile ===
--- 
+++ 
@@ -52,14 +52,6 @@
   # scripts will use both files, modulespath evaluated prior initrc. In this
   # case the modulespaths sets are only generated in modulespath config file.
 all: modulespath
-endif
-
-../version.inc:
-	$(MAKE) --no-print-directory -C .. version.inc
-
-# source version definitions shared across the Makefiles of this project
-ifeq ($(findstring clean,$(MAKECMDGOALS)),)
--include ../version.inc
 endif
 
 # define init configs location
@@ -241,10 +233,10 @@
 profile.sh: profile.sh.in
 	$(translate-in-script)
 
-$(EXAMPLE_MODFILES_SRCDIR)/modules: $(EXAMPLE_MODFILES_SRCDIR)/modules.in ../version.inc
-	$(translate-in-script)
-
-$(EXAMPLE_MODFILES_SRCDIR)/version: $(EXAMPLE_MODFILES_SRCDIR)/version.in ../version.inc
+$(EXAMPLE_MODFILES_SRCDIR)/modules: $(EXAMPLE_MODFILES_SRCDIR)/modules.in
+	$(translate-in-script)
+
+$(EXAMPLE_MODFILES_SRCDIR)/version: $(EXAMPLE_MODFILES_SRCDIR)/version.in
 	$(translate-in-script)
 
 dist-win:
@@ -330,3 +322,6 @@
 	rm -f $(DESTDIR)$(fishcompletiondir)/fish_completion
 endif
 	rm -f $(DESTDIR)$(zshcompletiondir)/_module
+	rm -f $(DESTDIR)$(modulespath) $(DESTDIR)$(initrc)
+	$(RMDIR_IGN_NON_EMPTY) $(DESTDIR)$(modulefilesdir) || true
+	@if [ -d $(DESTDIR)$(modulefilesdir) ]; then echo; echo "WARNING: $(DESTDIR)$(modulefilesdir) is not empty so skip removal" >&2; echo; fi
