=== debian/changelog ===
modules (5.1.1-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.6.1

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 01 Jun 2022 11:08:34 +0100
